/* LabelWithWidgets.c generated by valac 0.56.8, the Vala compiler
 * generated from LabelWithWidgets.vala, do not modify */

/* LabelWithWidgets is ported from Fractal*/
/* https://gitlab.gnome.org/GNOME/fractal/-/blob/071bfa9e2ad1574e675b2f90c3218565f9953f08/src/components/label_with_widgets.rs*/
/* How to use:*/
/* Set `text` to the label's content but use the `placeholder` keyword where widgets should be placed.*/
/* Then use `set_children` with an array of Widgets in order of how they should be placed in the label.*/
/* There are some helper functions like `append_child` to add children and*/
/* `LabelWithWidgets.with_label_and_widgets` to construct it with the desired text and widgets.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>

#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER "\xEF\xBF\xBC"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS (tuba_widgets_label_with_widgets_get_type ())
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_IS_LABEL_WITH_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS))
#define TUBA_WIDGETS_LABEL_WITH_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgetsClass))

typedef struct _TubaWidgetsLabelWithWidgets TubaWidgetsLabelWithWidgets;
typedef struct _TubaWidgetsLabelWithWidgetsClass TubaWidgetsLabelWithWidgetsClass;
typedef struct _TubaWidgetsLabelWithWidgetsPrivate TubaWidgetsLabelWithWidgetsPrivate;
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_0_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES
};
static GParamSpec* tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pango_attribute_destroy0(var) ((var == NULL) ? NULL : (var = (pango_attribute_destroy (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
#define __vala_PangoLayoutRun_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutRun_free (var), NULL)))
#define __vala_PangoLayoutIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoLayoutIter_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL,
	TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS
};
static guint tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_NUM_SIGNALS] = {0};

struct _TubaWidgetsLabelWithWidgets {
	GtkWidget parent_instance;
	TubaWidgetsLabelWithWidgetsPrivate * priv;
	GtkLabel* label;
};

struct _TubaWidgetsLabelWithWidgetsClass {
	GtkWidgetClass parent_class;
};

struct _TubaWidgetsLabelWithWidgetsPrivate {
	GtkWidget** widgets;
	gint widgets_length1;
	gint _widgets_size_;
	gint* widget_heights;
	gint widget_heights_length1;
	gint _widget_heights_size_;
	gint* widget_widths;
	gint widget_widths_length1;
	gint _widget_widths_size_;
	gchar* _placeholder;
	gchar* _text;
	gboolean _ellipsize;
	gboolean _use_markup;
};

static gint TubaWidgetsLabelWithWidgets_private_offset;
static gpointer tuba_widgets_label_with_widgets_parent_class = NULL;
static GtkBuildableIface * tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = NULL;
static GtkAccessibleInterface * tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = NULL;

VALA_EXTERN GType tuba_widgets_label_with_widgets_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TubaWidgetsLabelWithWidgets, g_object_unref)
static void tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self);
static PangoLayoutRun* _vala_PangoLayoutRun_copy (PangoLayoutRun* self);
static gint tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                                   gint d);
static void _vala_PangoLayoutRun_free (PangoLayoutRun* self);
static void _vala_PangoLayoutIter_free (PangoLayoutIter* self);
static void tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                         gint width,
                                                         gint height,
                                                         gint baseline);
static GtkSizeRequestMode tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base);
static void tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                                   GtkOrientation orientation,
                                                   gint for_size,
                                                   gint* minimum,
                                                   gint* natural,
                                                   gint* minimum_baseline,
                                                   gint* natural_baseline);
static void tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_ellipsize (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN const gchar* tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN gint tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self);
static void tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget* child);
static void _vala_array_add13 (GtkWidget** * array,
                        gint* length,
                        gint* size,
                        GtkWidget* value);
static void _vala_array_add14 (gint* * array,
                        gint* length,
                        gint* size,
                        gint value);
static void _vala_array_add15 (gint* * array,
                        gint* length,
                        gint* size,
                        gint value);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                                                         GtkWidget** t_widgets,
                                                                                         gint t_widgets_length1);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                                               const gchar* t_text,
                                                                                               GtkWidget** t_widgets,
                                                                                               gint t_widgets_length1);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                               const gchar* value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                                   GtkWidget** t_widgets,
                                                   gint t_widgets_length1);
static void tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                     GtkBuilder* builder,
                                                     GObject* child,
                                                     const gchar* type);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_new (void);
VALA_EXTERN TubaWidgetsLabelWithWidgets* tuba_widgets_label_with_widgets_construct (GType object_type);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                      const gchar* value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_ellipsize (TubaWidgetsLabelWithWidgets* self,
                                                    gboolean value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                           gboolean value);
VALA_EXTERN gfloat tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                                 gfloat value);
VALA_EXTERN gboolean tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                     gboolean value);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                                gint value);
VALA_EXTERN GtkJustification tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self);
VALA_EXTERN void tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                                  GtkJustification value);
static void g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * tuba_widgets_label_with_widgets_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static gboolean _tuba_widgets_label_with_widgets___lambda48_ (TubaWidgetsLabelWithWidgets* self,
                                                       const gchar* url);
static gboolean __tuba_widgets_label_with_widgets___lambda48__gtk_label_activate_link (GtkLabel* _sender,
                                                                                const gchar* uri,
                                                                                gpointer self);
static void _tuba_widgets_label_with_widgets___lambda49_ (TubaWidgetsLabelWithWidgets* self);
static void __tuba_widgets_label_with_widgets___lambda49__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void tuba_widgets_label_with_widgets_finalize (GObject * obj);
static GType tuba_widgets_label_with_widgets_get_type_once (void);
static void _vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
tuba_widgets_label_with_widgets_get_instance_private (TubaWidgetsLabelWithWidgets* self)
{
	return G_STRUCT_MEMBER_P (self, TubaWidgetsLabelWithWidgets_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 82 "../src/Widgets/LabelWithWidgets.vala"
	return self ? g_object_ref (self) : NULL;
#line 228 "LabelWithWidgets.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 252 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 260 "LabelWithWidgets.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 266 "LabelWithWidgets.c"
	}
}

static void
tuba_widgets_label_with_widgets_allocate_shapes (TubaWidgetsLabelWithWidgets* self)
{
	gboolean child_size_changed = FALSE;
	PangoAttrList* attrs = NULL;
	PangoAttrList* _tmp21_;
	gint index = 0;
	GtkLabel* _tmp44_;
	PangoAttrList* _tmp45_;
#line 87 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/Widgets/LabelWithWidgets.vala"
	child_size_changed = FALSE;
#line 283 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 288 "LabelWithWidgets.c"
		{
			gboolean _tmp0_ = FALSE;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
			_tmp0_ = TRUE;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 295 "LabelWithWidgets.c"
				GtkWidget** _tmp2_;
				gint _tmp2__length1;
				GtkWidget* child = NULL;
				GtkWidget** _tmp3_;
				gint _tmp3__length1;
				GtkWidget* _tmp4_;
				GtkWidget* _tmp5_;
				GtkRequisition size = {0};
				GtkRequisition natural_size = {0};
				GtkWidget* _tmp6_;
				GtkRequisition _tmp7_ = {0};
				GtkRequisition _tmp8_ = {0};
				gint width = 0;
				GtkRequisition _tmp9_;
				gint height = 0;
				GtkRequisition _tmp10_;
				gint* _tmp11_;
				gint _tmp11__length1;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp0_) {
#line 316 "LabelWithWidgets.c"
					gint _tmp1_;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
					_tmp1_ = i;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp1_ + 1;
#line 322 "LabelWithWidgets.c"
				}
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = FALSE;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2_ = self->priv->widgets;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2__length1 = self->priv->widgets_length1;
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp2__length1)) {
#line 90 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 334 "LabelWithWidgets.c"
				}
#line 91 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = self->priv->widgets;
#line 91 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3__length1 = self->priv->widgets_length1;
#line 91 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = _tmp3_[i];
#line 91 "../src/Widgets/LabelWithWidgets.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 91 "../src/Widgets/LabelWithWidgets.vala"
				child = _tmp5_;
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				_tmp6_ = child;
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_get_preferred_size (_tmp6_, &_tmp7_, &_tmp8_);
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				size = _tmp7_;
#line 94 "../src/Widgets/LabelWithWidgets.vala"
				natural_size = _tmp8_;
#line 95 "../src/Widgets/LabelWithWidgets.vala"
				_tmp9_ = natural_size;
#line 95 "../src/Widgets/LabelWithWidgets.vala"
				width = _tmp9_.width;
#line 96 "../src/Widgets/LabelWithWidgets.vala"
				_tmp10_ = natural_size;
#line 96 "../src/Widgets/LabelWithWidgets.vala"
				height = _tmp10_.height;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				_tmp11_ = self->priv->widget_widths;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				_tmp11__length1 = self->priv->widget_widths_length1;
#line 98 "../src/Widgets/LabelWithWidgets.vala"
				if (_tmp11__length1 > 0) {
#line 368 "LabelWithWidgets.c"
					gint old_width = 0;
					gint* _tmp12_;
					gint _tmp12__length1;
					gint _tmp13_;
					gint old_height = 0;
					gint* _tmp14_;
					gint _tmp14__length1;
					gint _tmp15_;
					gboolean _tmp16_ = FALSE;
#line 99 "../src/Widgets/LabelWithWidgets.vala"
					_tmp12_ = self->priv->widget_widths;
#line 99 "../src/Widgets/LabelWithWidgets.vala"
					_tmp12__length1 = self->priv->widget_widths_length1;
#line 99 "../src/Widgets/LabelWithWidgets.vala"
					_tmp13_ = _tmp12_[i];
#line 99 "../src/Widgets/LabelWithWidgets.vala"
					old_width = _tmp13_;
#line 100 "../src/Widgets/LabelWithWidgets.vala"
					_tmp14_ = self->priv->widget_heights;
#line 100 "../src/Widgets/LabelWithWidgets.vala"
					_tmp14__length1 = self->priv->widget_heights_length1;
#line 100 "../src/Widgets/LabelWithWidgets.vala"
					_tmp15_ = _tmp14_[i];
#line 100 "../src/Widgets/LabelWithWidgets.vala"
					old_height = _tmp15_;
#line 101 "../src/Widgets/LabelWithWidgets.vala"
					if (old_width != width) {
#line 101 "../src/Widgets/LabelWithWidgets.vala"
						_tmp16_ = TRUE;
#line 398 "LabelWithWidgets.c"
					} else {
#line 101 "../src/Widgets/LabelWithWidgets.vala"
						_tmp16_ = old_height != height;
#line 402 "LabelWithWidgets.c"
					}
#line 101 "../src/Widgets/LabelWithWidgets.vala"
					if (_tmp16_) {
#line 406 "LabelWithWidgets.c"
						gint* _tmp17_;
						gint _tmp17__length1;
						gint* _tmp18_;
						gint _tmp18__length1;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
						_tmp17_ = self->priv->widget_widths;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
						_tmp17__length1 = self->priv->widget_widths_length1;
#line 102 "../src/Widgets/LabelWithWidgets.vala"
						_tmp17_[i] = width;
#line 103 "../src/Widgets/LabelWithWidgets.vala"
						_tmp18_ = self->priv->widget_heights;
#line 103 "../src/Widgets/LabelWithWidgets.vala"
						_tmp18__length1 = self->priv->widget_heights_length1;
#line 103 "../src/Widgets/LabelWithWidgets.vala"
						_tmp18_[i] = height;
#line 105 "../src/Widgets/LabelWithWidgets.vala"
						child_size_changed = TRUE;
#line 425 "LabelWithWidgets.c"
					}
				} else {
					gint* _tmp19_;
					gint _tmp19__length1;
					gint* _tmp20_;
					gint _tmp20__length1;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19_ = self->priv->widget_widths;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19__length1 = self->priv->widget_widths_length1;
#line 108 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19_[i] = width;
#line 109 "../src/Widgets/LabelWithWidgets.vala"
					_tmp20_ = self->priv->widget_heights;
#line 109 "../src/Widgets/LabelWithWidgets.vala"
					_tmp20__length1 = self->priv->widget_heights_length1;
#line 109 "../src/Widgets/LabelWithWidgets.vala"
					_tmp20_[i] = height;
#line 111 "../src/Widgets/LabelWithWidgets.vala"
					child_size_changed = TRUE;
#line 446 "LabelWithWidgets.c"
				}
#line 90 "../src/Widgets/LabelWithWidgets.vala"
				_g_object_unref0 (child);
#line 450 "LabelWithWidgets.c"
			}
		}
	}
#line 116 "../src/Widgets/LabelWithWidgets.vala"
	if (!child_size_changed) {
#line 117 "../src/Widgets/LabelWithWidgets.vala"
		return;
#line 458 "LabelWithWidgets.c"
	}
#line 120 "../src/Widgets/LabelWithWidgets.vala"
	_tmp21_ = pango_attr_list_new ();
#line 120 "../src/Widgets/LabelWithWidgets.vala"
	attrs = _tmp21_;
#line 121 "../src/Widgets/LabelWithWidgets.vala"
	index = 0;
#line 466 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 471 "LabelWithWidgets.c"
		{
			gboolean _tmp22_ = FALSE;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
			_tmp22_ = TRUE;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 478 "LabelWithWidgets.c"
				gint* _tmp24_;
				gint _tmp24__length1;
				GtkLabel* _tmp25_;
				const gchar* _tmp26_;
				gint width = 0;
				gint* _tmp27_;
				gint _tmp27__length1;
				gint _tmp28_;
				gint height = 0;
				gint* _tmp29_;
				gint _tmp29__length1;
				gint _tmp30_;
				PangoRectangle logical_rect = {0};
				PangoRectangle _tmp31_ = {0};
				PangoAttribute* shape = NULL;
				PangoRectangle _tmp32_;
				PangoRectangle _tmp33_;
				PangoAttribute* _tmp34_;
				PangoAttribute* _tmp35_;
				PangoAttribute* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				PangoAttrList* _tmp39_;
				PangoAttribute* _tmp40_;
				PangoAttribute* _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp22_) {
#line 508 "LabelWithWidgets.c"
					gint _tmp23_;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_ = i;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp23_ + 1;
#line 514 "LabelWithWidgets.c"
				}
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				_tmp22_ = FALSE;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				_tmp24_ = self->priv->widget_widths;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				_tmp24__length1 = self->priv->widget_widths_length1;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp24__length1)) {
#line 123 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 526 "LabelWithWidgets.c"
				}
#line 124 "../src/Widgets/LabelWithWidgets.vala"
				_tmp25_ = self->label;
#line 124 "../src/Widgets/LabelWithWidgets.vala"
				_tmp26_ = gtk_label_get_text (_tmp25_);
#line 124 "../src/Widgets/LabelWithWidgets.vala"
				index = string_index_of (_tmp26_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER, index);
#line 125 "../src/Widgets/LabelWithWidgets.vala"
				if (index < 0) {
#line 125 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 538 "LabelWithWidgets.c"
				}
#line 127 "../src/Widgets/LabelWithWidgets.vala"
				_tmp27_ = self->priv->widget_widths;
#line 127 "../src/Widgets/LabelWithWidgets.vala"
				_tmp27__length1 = self->priv->widget_widths_length1;
#line 127 "../src/Widgets/LabelWithWidgets.vala"
				_tmp28_ = _tmp27_[i];
#line 127 "../src/Widgets/LabelWithWidgets.vala"
				width = _tmp28_;
#line 128 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29_ = self->priv->widget_heights;
#line 128 "../src/Widgets/LabelWithWidgets.vala"
				_tmp29__length1 = self->priv->widget_heights_length1;
#line 128 "../src/Widgets/LabelWithWidgets.vala"
				_tmp30_ = _tmp29_[i];
#line 128 "../src/Widgets/LabelWithWidgets.vala"
				height = _tmp30_;
#line 129 "../src/Widgets/LabelWithWidgets.vala"
				memset (&_tmp31_, 0, sizeof (PangoRectangle));
#line 129 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31_.x = 0;
#line 129 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31_.y = (-(height - (height / 4))) * PANGO_SCALE;
#line 129 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31_.width = width * PANGO_SCALE;
#line 129 "../src/Widgets/LabelWithWidgets.vala"
				_tmp31_.height = height * PANGO_SCALE;
#line 129 "../src/Widgets/LabelWithWidgets.vala"
				logical_rect = _tmp31_;
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				_tmp32_ = logical_rect;
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				_tmp33_ = logical_rect;
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				_tmp34_ = pango_attr_shape_new (&_tmp32_, &_tmp33_);
#line 136 "../src/Widgets/LabelWithWidgets.vala"
				shape = _tmp34_;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_ = shape;
#line 137 "../src/Widgets/LabelWithWidgets.vala"
				_tmp35_->start_index = (guint) index;
#line 138 "../src/Widgets/LabelWithWidgets.vala"
				_tmp36_ = shape;
#line 138 "../src/Widgets/LabelWithWidgets.vala"
				_tmp37_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 138 "../src/Widgets/LabelWithWidgets.vala"
				_tmp38_ = _tmp37_;
#line 138 "../src/Widgets/LabelWithWidgets.vala"
				_tmp36_->end_index = (guint) (index + _tmp38_);
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				_tmp39_ = attrs;
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				_tmp40_ = shape;
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				_tmp41_ = pango_attribute_copy (_tmp40_);
#line 139 "../src/Widgets/LabelWithWidgets.vala"
				pango_attr_list_insert (_tmp39_, _tmp41_);
#line 141 "../src/Widgets/LabelWithWidgets.vala"
				_tmp42_ = strlen (TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 141 "../src/Widgets/LabelWithWidgets.vala"
				_tmp43_ = _tmp42_;
#line 141 "../src/Widgets/LabelWithWidgets.vala"
				index = index + _tmp43_;
#line 123 "../src/Widgets/LabelWithWidgets.vala"
				_pango_attribute_destroy0 (shape);
#line 604 "LabelWithWidgets.c"
			}
		}
	}
#line 144 "../src/Widgets/LabelWithWidgets.vala"
	_tmp44_ = self->label;
#line 144 "../src/Widgets/LabelWithWidgets.vala"
	_tmp45_ = attrs;
#line 144 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_attributes (_tmp44_, _tmp45_);
#line 87 "../src/Widgets/LabelWithWidgets.vala"
	_pango_attr_list_unref0 (attrs);
#line 616 "LabelWithWidgets.c"
}

static PangoLayoutRun*
_vala_PangoLayoutRun_copy (PangoLayoutRun* self)
{
#line 152 "../src/Widgets/LabelWithWidgets.vala"
	return g_boxed_copy (pango_glyph_item_get_type (), self);
#line 624 "LabelWithWidgets.c"
}

static gpointer
__vala_PangoLayoutRun_copy0 (gpointer self)
{
#line 152 "../src/Widgets/LabelWithWidgets.vala"
	return self ? _vala_PangoLayoutRun_copy (self) : NULL;
#line 632 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutRun_free (PangoLayoutRun* self)
{
#line 186 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_glyph_item_get_type (), self);
#line 640 "LabelWithWidgets.c"
}

static void
_vala_PangoLayoutIter_free (PangoLayoutIter* self)
{
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	g_boxed_free (pango_layout_iter_get_type (), self);
#line 648 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_allocate_children (TubaWidgetsLabelWithWidgets* self)
{
	PangoLayoutIter* run_iter = NULL;
	GtkLabel* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayoutIter* _tmp2_;
	gint i = 0;
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 148 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_layout (_tmp0_);
#line 148 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = pango_layout_get_iter (_tmp1_);
#line 148 "../src/Widgets/LabelWithWidgets.vala"
	run_iter = _tmp2_;
#line 149 "../src/Widgets/LabelWithWidgets.vala"
	i = 0;
#line 151 "../src/Widgets/LabelWithWidgets.vala"
	while (TRUE) {
#line 673 "LabelWithWidgets.c"
		PangoLayoutRun* run = NULL;
		PangoLayoutIter* _tmp3_;
		PangoLayoutRun* _tmp4_;
		PangoLayoutRun* _tmp5_;
		PangoLayoutRun* _tmp6_;
		PangoLayoutIter* _tmp35_;
#line 152 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = run_iter;
#line 152 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = pango_layout_iter_get_run_readonly (_tmp3_);
#line 152 "../src/Widgets/LabelWithWidgets.vala"
		_tmp5_ = __vala_PangoLayoutRun_copy0 (_tmp4_);
#line 152 "../src/Widgets/LabelWithWidgets.vala"
		run = _tmp5_;
#line 153 "../src/Widgets/LabelWithWidgets.vala"
		_tmp6_ = run;
#line 153 "../src/Widgets/LabelWithWidgets.vala"
		if (_tmp6_ != NULL) {
#line 692 "LabelWithWidgets.c"
			GSList* extra_attrs = NULL;
			PangoLayoutRun* _tmp7_;
			PangoItem* _tmp8_;
			PangoAnalysis _tmp9_;
			GSList* _tmp10_;
			GSList* _tmp11_;
			gboolean has_shape_attr = FALSE;
			GSList* _tmp12_;
#line 154 "../src/Widgets/LabelWithWidgets.vala"
			_tmp7_ = run;
#line 154 "../src/Widgets/LabelWithWidgets.vala"
			_tmp8_ = ((PangoGlyphItem*) _tmp7_)->item;
#line 154 "../src/Widgets/LabelWithWidgets.vala"
			_tmp9_ = _tmp8_->analysis;
#line 154 "../src/Widgets/LabelWithWidgets.vala"
			_tmp10_ = _tmp9_.extra_attrs;
#line 154 "../src/Widgets/LabelWithWidgets.vala"
			_tmp11_ = g_slist_copy (_tmp10_);
#line 154 "../src/Widgets/LabelWithWidgets.vala"
			extra_attrs = _tmp11_;
#line 155 "../src/Widgets/LabelWithWidgets.vala"
			has_shape_attr = FALSE;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
			_tmp12_ = extra_attrs;
#line 717 "LabelWithWidgets.c"
			{
				GSList* attr_collection = NULL;
				GSList* attr_it = NULL;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
				attr_collection = _tmp12_;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
				for (attr_it = attr_collection; attr_it != NULL; attr_it = attr_it->next) {
#line 725 "LabelWithWidgets.c"
					void* attr = NULL;
#line 156 "../src/Widgets/LabelWithWidgets.vala"
					attr = attr_it->data;
#line 729 "LabelWithWidgets.c"
					{
						void* _tmp13_;
						PangoAttrShape* _tmp14_;
#line 157 "../src/Widgets/LabelWithWidgets.vala"
						_tmp13_ = attr;
#line 157 "../src/Widgets/LabelWithWidgets.vala"
						_tmp14_ = pango_attribute_as_shape ((PangoAttribute*) _tmp13_);
#line 157 "../src/Widgets/LabelWithWidgets.vala"
						if (_tmp14_ != NULL) {
#line 158 "../src/Widgets/LabelWithWidgets.vala"
							has_shape_attr = TRUE;
#line 159 "../src/Widgets/LabelWithWidgets.vala"
							break;
#line 743 "LabelWithWidgets.c"
						}
					}
				}
			}
#line 163 "../src/Widgets/LabelWithWidgets.vala"
			if (has_shape_attr) {
#line 750 "LabelWithWidgets.c"
				GtkWidget** _tmp15_;
				gint _tmp15__length1;
#line 164 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15_ = self->priv->widgets;
#line 164 "../src/Widgets/LabelWithWidgets.vala"
				_tmp15__length1 = self->priv->widgets_length1;
#line 164 "../src/Widgets/LabelWithWidgets.vala"
				if (i < _tmp15__length1) {
#line 759 "LabelWithWidgets.c"
					GtkWidget* widget = NULL;
					GtkWidget** _tmp16_;
					gint _tmp16__length1;
					GtkWidget* _tmp17_;
					GtkWidget* _tmp18_;
					gint width = 0;
					gint* _tmp19_;
					gint _tmp19__length1;
					gint _tmp20_;
					gint height = 0;
					gint* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_;
					PangoRectangle ink_rect = {0};
					PangoRectangle logical_rect = {0};
					PangoLayoutIter* _tmp23_;
					PangoRectangle _tmp24_ = {0};
					PangoRectangle _tmp25_ = {0};
					gint offset_x = 0;
					gint offset_y = 0;
					GtkLabel* _tmp26_;
					gint _tmp27_ = 0;
					gint _tmp28_ = 0;
					GtkAllocation allocation = {0};
					PangoRectangle _tmp29_;
					PangoRectangle _tmp30_;
					GtkAllocation _tmp31_ = {0};
					GtkWidget* _tmp32_;
					GtkAllocation _tmp33_;
					gint _tmp34_;
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					_tmp16_ = self->priv->widgets;
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					_tmp16__length1 = self->priv->widgets_length1;
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					_tmp17_ = _tmp16_[i];
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					_tmp18_ = _g_object_ref0 (_tmp17_);
#line 165 "../src/Widgets/LabelWithWidgets.vala"
					widget = _tmp18_;
#line 166 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19_ = self->priv->widget_widths;
#line 166 "../src/Widgets/LabelWithWidgets.vala"
					_tmp19__length1 = self->priv->widget_widths_length1;
#line 166 "../src/Widgets/LabelWithWidgets.vala"
					_tmp20_ = _tmp19_[i];
#line 166 "../src/Widgets/LabelWithWidgets.vala"
					width = _tmp20_;
#line 167 "../src/Widgets/LabelWithWidgets.vala"
					_tmp21_ = self->priv->widget_heights;
#line 167 "../src/Widgets/LabelWithWidgets.vala"
					_tmp21__length1 = self->priv->widget_heights_length1;
#line 167 "../src/Widgets/LabelWithWidgets.vala"
					_tmp22_ = _tmp21_[i];
#line 167 "../src/Widgets/LabelWithWidgets.vala"
					height = _tmp22_;
#line 171 "../src/Widgets/LabelWithWidgets.vala"
					_tmp23_ = run_iter;
#line 171 "../src/Widgets/LabelWithWidgets.vala"
					pango_layout_iter_get_run_extents (_tmp23_, &_tmp24_, &_tmp25_);
#line 171 "../src/Widgets/LabelWithWidgets.vala"
					ink_rect = _tmp24_;
#line 171 "../src/Widgets/LabelWithWidgets.vala"
					logical_rect = _tmp25_;
#line 175 "../src/Widgets/LabelWithWidgets.vala"
					_tmp26_ = self->label;
#line 175 "../src/Widgets/LabelWithWidgets.vala"
					gtk_label_get_layout_offsets (_tmp26_, &_tmp27_, &_tmp28_);
#line 175 "../src/Widgets/LabelWithWidgets.vala"
					offset_x = _tmp27_;
#line 175 "../src/Widgets/LabelWithWidgets.vala"
					offset_y = _tmp28_;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					_tmp29_ = logical_rect;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					_tmp30_ = logical_rect;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					memset (&_tmp31_, 0, sizeof (GtkAllocation));
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31_.x = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp29_.x) + offset_x;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31_.y = tuba_widgets_label_with_widgets_pango_pixels (self, _tmp30_.y) + offset_y;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31_.height = width;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					_tmp31_.width = height;
#line 177 "../src/Widgets/LabelWithWidgets.vala"
					allocation = _tmp31_;
#line 183 "../src/Widgets/LabelWithWidgets.vala"
					_tmp32_ = widget;
#line 183 "../src/Widgets/LabelWithWidgets.vala"
					_tmp33_ = allocation;
#line 183 "../src/Widgets/LabelWithWidgets.vala"
					gtk_widget_size_allocate (_tmp32_, &_tmp33_, -1);
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					_tmp34_ = i;
#line 184 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp34_ + 1;
#line 164 "../src/Widgets/LabelWithWidgets.vala"
					_g_object_unref0 (widget);
#line 860 "LabelWithWidgets.c"
				} else {
#line 186 "../src/Widgets/LabelWithWidgets.vala"
					(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 186 "../src/Widgets/LabelWithWidgets.vala"
					__vala_PangoLayoutRun_free0 (run);
#line 186 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 868 "LabelWithWidgets.c"
				}
			}
#line 153 "../src/Widgets/LabelWithWidgets.vala"
			(extra_attrs == NULL) ? NULL : (extra_attrs = (g_slist_free (extra_attrs), NULL));
#line 873 "LabelWithWidgets.c"
		}
#line 191 "../src/Widgets/LabelWithWidgets.vala"
		_tmp35_ = run_iter;
#line 191 "../src/Widgets/LabelWithWidgets.vala"
		if (!pango_layout_iter_next_run (_tmp35_)) {
#line 192 "../src/Widgets/LabelWithWidgets.vala"
			__vala_PangoLayoutRun_free0 (run);
#line 192 "../src/Widgets/LabelWithWidgets.vala"
			break;
#line 883 "LabelWithWidgets.c"
		}
#line 151 "../src/Widgets/LabelWithWidgets.vala"
		__vala_PangoLayoutRun_free0 (run);
#line 887 "LabelWithWidgets.c"
	}
#line 147 "../src/Widgets/LabelWithWidgets.vala"
	__vala_PangoLayoutIter_free0 (run_iter);
#line 891 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_size_allocate (GtkWidget* base,
                                                    gint width,
                                                    gint height,
                                                    gint baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
#line 197 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 198 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 198 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp0_, width, height, baseline, NULL);
#line 199 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_children (self);
#line 910 "LabelWithWidgets.c"
}

static GtkSizeRequestMode
tuba_widgets_label_with_widgets_real_get_request_mode (GtkWidget* base)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	GtkSizeRequestMode result;
#line 202 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 203 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 203 "../src/Widgets/LabelWithWidgets.vala"
	result = gtk_widget_get_request_mode ((GtkWidget*) _tmp0_);
#line 203 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 927 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_measure (GtkWidget* base,
                                              GtkOrientation orientation,
                                              gint for_size,
                                              gint* minimum,
                                              gint* natural,
                                              gint* minimum_baseline,
                                              gint* natural_baseline)
{
	TubaWidgetsLabelWithWidgets * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _vala_minimum_baseline = 0;
	gint _vala_natural_baseline = 0;
	GtkLabel* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 206 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 207 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_allocate_shapes (self);
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_measure ((GtkWidget*) _tmp0_, orientation, for_size, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum = _tmp1_;
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural = _tmp2_;
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	_vala_minimum_baseline = _tmp3_;
#line 208 "../src/Widgets/LabelWithWidgets.vala"
	_vala_natural_baseline = _tmp4_;
#line 206 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum) {
#line 206 "../src/Widgets/LabelWithWidgets.vala"
		*minimum = _vala_minimum;
#line 969 "LabelWithWidgets.c"
	}
#line 206 "../src/Widgets/LabelWithWidgets.vala"
	if (natural) {
#line 206 "../src/Widgets/LabelWithWidgets.vala"
		*natural = _vala_natural;
#line 975 "LabelWithWidgets.c"
	}
#line 206 "../src/Widgets/LabelWithWidgets.vala"
	if (minimum_baseline) {
#line 206 "../src/Widgets/LabelWithWidgets.vala"
		*minimum_baseline = _vala_minimum_baseline;
#line 981 "LabelWithWidgets.c"
	}
#line 206 "../src/Widgets/LabelWithWidgets.vala"
	if (natural_baseline) {
#line 206 "../src/Widgets/LabelWithWidgets.vala"
		*natural_baseline = _vala_natural_baseline;
#line 987 "LabelWithWidgets.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1010 "LabelWithWidgets.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1014 "LabelWithWidgets.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1020 "LabelWithWidgets.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1024 "LabelWithWidgets.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1028 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1036 "LabelWithWidgets.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1064 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1073 "LabelWithWidgets.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1087 "LabelWithWidgets.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1096 "LabelWithWidgets.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1110 "LabelWithWidgets.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1119 "LabelWithWidgets.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1128 "LabelWithWidgets.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1150 "LabelWithWidgets.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 1158 "LabelWithWidgets.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 1164 "LabelWithWidgets.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 1188 "LabelWithWidgets.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 1197 "LabelWithWidgets.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1216 "LabelWithWidgets.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1220 "LabelWithWidgets.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1226 "LabelWithWidgets.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1236 "LabelWithWidgets.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1244 "LabelWithWidgets.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1248 "LabelWithWidgets.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 1254 "LabelWithWidgets.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 1264 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_update_label (TubaWidgetsLabelWithWidgets* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 211 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = tuba_widgets_label_with_widgets_get_ellipsize (self);
#line 212 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = _tmp0_;
#line 212 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp1_) {
#line 1280 "LabelWithWidgets.c"
		GtkLabel* _tmp2_;
		GtkLabel* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 215 "../src/Widgets/LabelWithWidgets.vala"
		_tmp2_ = self->label;
#line 215 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_wrap (_tmp2_, FALSE);
#line 216 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = self->label;
#line 216 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_ellipsize (_tmp3_, PANGO_ELLIPSIZE_END);
#line 218 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = tuba_widgets_label_with_widgets_get_text (self);
#line 218 "../src/Widgets/LabelWithWidgets.vala"
		_tmp5_ = _tmp4_;
#line 218 "../src/Widgets/LabelWithWidgets.vala"
		if (_tmp5_ != NULL) {
#line 1299 "LabelWithWidgets.c"
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gint pos = 0;
			const gchar* _tmp10_;
			GtkLabel* _tmp15_;
			const gchar* _tmp16_;
#line 219 "../src/Widgets/LabelWithWidgets.vala"
			_tmp6_ = self->priv->_text;
#line 219 "../src/Widgets/LabelWithWidgets.vala"
			_tmp7_ = tuba_widgets_label_with_widgets_get_placeholder (self);
#line 219 "../src/Widgets/LabelWithWidgets.vala"
			_tmp8_ = _tmp7_;
#line 219 "../src/Widgets/LabelWithWidgets.vala"
			_tmp9_ = string_replace (_tmp6_, _tmp8_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 219 "../src/Widgets/LabelWithWidgets.vala"
			_g_free0 (self->priv->_text);
#line 219 "../src/Widgets/LabelWithWidgets.vala"
			self->priv->_text = _tmp9_;
#line 221 "../src/Widgets/LabelWithWidgets.vala"
			_tmp10_ = self->priv->_text;
#line 221 "../src/Widgets/LabelWithWidgets.vala"
			pos = string_index_of_char (_tmp10_, (gunichar) '\n', 0);
#line 222 "../src/Widgets/LabelWithWidgets.vala"
			if (pos >= 0) {
#line 1326 "LabelWithWidgets.c"
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
#line 223 "../src/Widgets/LabelWithWidgets.vala"
				_tmp11_ = self->priv->_text;
#line 223 "../src/Widgets/LabelWithWidgets.vala"
				_tmp12_ = string_substring (_tmp11_, (glong) 0, (glong) pos);
#line 223 "../src/Widgets/LabelWithWidgets.vala"
				_tmp13_ = _tmp12_;
#line 223 "../src/Widgets/LabelWithWidgets.vala"
				_tmp14_ = g_strconcat (_tmp13_, "…", NULL);
#line 223 "../src/Widgets/LabelWithWidgets.vala"
				_g_free0 (self->priv->_text);
#line 223 "../src/Widgets/LabelWithWidgets.vala"
				self->priv->_text = _tmp14_;
#line 223 "../src/Widgets/LabelWithWidgets.vala"
				_g_free0 (_tmp13_);
#line 1345 "LabelWithWidgets.c"
			}
#line 226 "../src/Widgets/LabelWithWidgets.vala"
			_tmp15_ = self->label;
#line 226 "../src/Widgets/LabelWithWidgets.vala"
			_tmp16_ = self->priv->_text;
#line 226 "../src/Widgets/LabelWithWidgets.vala"
			gtk_label_set_label (_tmp15_, _tmp16_);
#line 1353 "LabelWithWidgets.c"
		}
	} else {
		GtkLabel* _tmp17_;
		GtkLabel* _tmp18_;
		PangoEllipsizeMode _tmp19_ = 0;
		gint _tmp20_;
		gint _tmp21_;
		GtkLabel* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
#line 229 "../src/Widgets/LabelWithWidgets.vala"
		_tmp17_ = self->label;
#line 229 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_wrap (_tmp17_, TRUE);
#line 230 "../src/Widgets/LabelWithWidgets.vala"
		_tmp18_ = self->label;
#line 230 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_wrap_mode (_tmp18_, PANGO_WRAP_WORD_CHAR);
#line 233 "../src/Widgets/LabelWithWidgets.vala"
		_tmp20_ = tuba_widgets_label_with_widgets_get_lines (self);
#line 233 "../src/Widgets/LabelWithWidgets.vala"
		_tmp21_ = _tmp20_;
#line 233 "../src/Widgets/LabelWithWidgets.vala"
		if (_tmp21_ != 100) {
#line 233 "../src/Widgets/LabelWithWidgets.vala"
			_tmp19_ = PANGO_ELLIPSIZE_NONE;
#line 1380 "LabelWithWidgets.c"
		} else {
#line 233 "../src/Widgets/LabelWithWidgets.vala"
			_tmp19_ = PANGO_ELLIPSIZE_END;
#line 1384 "LabelWithWidgets.c"
		}
#line 233 "../src/Widgets/LabelWithWidgets.vala"
		_tmp22_ = self->label;
#line 233 "../src/Widgets/LabelWithWidgets.vala"
		gtk_label_set_ellipsize (_tmp22_, _tmp19_);
#line 235 "../src/Widgets/LabelWithWidgets.vala"
		_tmp23_ = tuba_widgets_label_with_widgets_get_text (self);
#line 235 "../src/Widgets/LabelWithWidgets.vala"
		_tmp24_ = _tmp23_;
#line 235 "../src/Widgets/LabelWithWidgets.vala"
		if (_tmp24_ != NULL) {
#line 1396 "LabelWithWidgets.c"
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			GtkLabel* _tmp29_;
			const gchar* _tmp30_;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp25_ = self->priv->_text;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp26_ = tuba_widgets_label_with_widgets_get_placeholder (self);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp27_ = _tmp26_;
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_tmp28_ = string_replace (_tmp25_, _tmp27_, TUBA_WIDGETS_LABEL_WITH_WIDGETS_OBJECT_REPLACEMENT_CHARACTER);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			_g_free0 (self->priv->_text);
#line 236 "../src/Widgets/LabelWithWidgets.vala"
			self->priv->_text = _tmp28_;
#line 237 "../src/Widgets/LabelWithWidgets.vala"
			_tmp29_ = self->label;
#line 237 "../src/Widgets/LabelWithWidgets.vala"
			_tmp30_ = self->priv->_text;
#line 237 "../src/Widgets/LabelWithWidgets.vala"
			gtk_label_set_label (_tmp29_, _tmp30_);
#line 1421 "LabelWithWidgets.c"
		}
	}
#line 241 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1426 "LabelWithWidgets.c"
}

static void
_vala_array_add13 (GtkWidget** * array,
                   gint* length,
                   gint* size,
                   GtkWidget* value)
{
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 245 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 245 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (GtkWidget*, *array, (*size) + 1);
#line 1441 "LabelWithWidgets.c"
	}
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = value;
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[*length] = NULL;
#line 1447 "LabelWithWidgets.c"
}

static void
_vala_array_add14 (gint* * array,
                   gint* length,
                   gint* size,
                   gint value)
{
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 246 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 246 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (gint, *array, *size);
#line 1462 "LabelWithWidgets.c"
	}
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = value;
#line 1466 "LabelWithWidgets.c"
}

static void
_vala_array_add15 (gint* * array,
                   gint* length,
                   gint* size,
                   gint value)
{
#line 247 "../src/Widgets/LabelWithWidgets.vala"
	if ((*length) == (*size)) {
#line 247 "../src/Widgets/LabelWithWidgets.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 247 "../src/Widgets/LabelWithWidgets.vala"
		*array = g_renew (gint, *array, *size);
#line 1481 "LabelWithWidgets.c"
	}
#line 247 "../src/Widgets/LabelWithWidgets.vala"
	(*array)[(*length)++] = value;
#line 1485 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_append_child (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget* child)
{
	GtkWidget* _tmp0_;
#line 244 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (child);
#line 245 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add13 (&self->priv->widgets, &self->priv->widgets_length1, &self->priv->_widgets_size_, _tmp0_);
#line 246 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add14 (&self->priv->widget_widths, &self->priv->widget_widths_length1, &self->priv->_widget_widths_size_, 0);
#line 247 "../src/Widgets/LabelWithWidgets.vala"
	_vala_array_add15 (&self->priv->widget_heights, &self->priv->widget_heights_length1, &self->priv->_widget_heights_size_, 0);
#line 249 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent (child, (GtkWidget*) self);
#line 251 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 1509 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct_with_label_and_widgets (GType object_type,
                                                                  const gchar* t_text,
                                                                  GtkWidget** t_widgets,
                                                                  gint t_widgets_length1)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 254 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (t_text != NULL, NULL);
#line 255 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 1523 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 257 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 257 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 257 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1535 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 257 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1539 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp0_;
#line 258 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = widget;
#line 258 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp0_);
#line 1546 "LabelWithWidgets.c"
			}
		}
	}
#line 261 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_set_text (self, t_text);
#line 254 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 1554 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new_with_label_and_widgets (const gchar* t_text,
                                                            GtkWidget** t_widgets,
                                                            gint t_widgets_length1)
{
#line 254 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct_with_label_and_widgets (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, t_text, t_widgets, t_widgets_length1);
#line 1564 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_children (TubaWidgetsLabelWithWidgets* self,
                                              GtkWidget** t_widgets,
                                              gint t_widgets_length1)
{
	GtkWidget** _tmp0_;
	gint _tmp0__length1;
	GtkWidget** _tmp4_;
	gint* _tmp5_;
	gint* _tmp6_;
#line 264 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->widgets;
#line 265 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0__length1 = self->priv->widgets_length1;
#line 1583 "LabelWithWidgets.c"
	{
		GtkWidget** child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 265 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp0_;
#line 265 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp0__length1;
#line 265 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 1595 "LabelWithWidgets.c"
			GtkWidget* _tmp1_;
			GtkWidget* child = NULL;
#line 265 "../src/Widgets/LabelWithWidgets.vala"
			_tmp1_ = _g_object_ref0 (child_collection[child_it]);
#line 265 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp1_;
#line 1602 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp2_;
				GtkWidget* _tmp3_;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2_ = child;
#line 266 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp2_);
#line 267 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = child;
#line 267 "../src/Widgets/LabelWithWidgets.vala"
				g_signal_emit_by_name (_tmp3_, "destroy");
#line 265 "../src/Widgets/LabelWithWidgets.vala"
				_g_object_unref0 (child);
#line 1616 "LabelWithWidgets.c"
			}
		}
	}
#line 270 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = g_new0 (GtkWidget*, 0 + 1);
#line 270 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_array_free (self->priv->widgets, self->priv->widgets_length1, (GDestroyNotify) g_object_unref), NULL);
#line 270 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp4_;
#line 270 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 270 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	_tmp5_ = g_new0 (gint, 0);
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = (g_free (self->priv->widget_widths), NULL);
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = _tmp5_;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths_length1 = 0;
#line 271 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_widths_size_ = self->priv->widget_widths_length1;
#line 272 "../src/Widgets/LabelWithWidgets.vala"
	_tmp6_ = g_new0 (gint, 0);
#line 272 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = (g_free (self->priv->widget_heights), NULL);
#line 272 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = _tmp6_;
#line 272 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights_length1 = 0;
#line 272 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_heights_size_ = self->priv->widget_heights_length1;
#line 1650 "LabelWithWidgets.c"
	{
		GtkWidget** widget_collection = NULL;
		gint widget_collection_length1 = 0;
		gint _widget_collection_size_ = 0;
		gint widget_it = 0;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection = t_widgets;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
		widget_collection_length1 = t_widgets_length1;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
		for (widget_it = 0; widget_it < widget_collection_length1; widget_it = widget_it + 1) {
#line 1662 "LabelWithWidgets.c"
			GtkWidget* widget = NULL;
#line 274 "../src/Widgets/LabelWithWidgets.vala"
			widget = widget_collection[widget_it];
#line 1666 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp7_;
#line 275 "../src/Widgets/LabelWithWidgets.vala"
				_tmp7_ = widget;
#line 275 "../src/Widgets/LabelWithWidgets.vala"
				tuba_widgets_label_with_widgets_append_child (self, _tmp7_);
#line 1673 "LabelWithWidgets.c"
			}
		}
	}
}

static void
tuba_widgets_label_with_widgets_invalidate_child_widgets (TubaWidgetsLabelWithWidgets* self)
{
#line 279 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 1684 "LabelWithWidgets.c"
	{
		gint i = 0;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
		i = 0;
#line 1689 "LabelWithWidgets.c"
		{
			gboolean _tmp0_ = FALSE;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
			_tmp0_ = TRUE;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
			while (TRUE) {
#line 1696 "LabelWithWidgets.c"
				gint* _tmp2_;
				gint _tmp2__length1;
				gint* _tmp3_;
				gint _tmp3__length1;
				gint* _tmp4_;
				gint _tmp4__length1;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				if (!_tmp0_) {
#line 1705 "LabelWithWidgets.c"
					gint _tmp1_;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					_tmp1_ = i;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					i = _tmp1_ + 1;
#line 1711 "LabelWithWidgets.c"
				}
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				_tmp0_ = FALSE;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2_ = self->priv->widget_widths;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				_tmp2__length1 = self->priv->widget_widths_length1;
#line 280 "../src/Widgets/LabelWithWidgets.vala"
				if (!(i < _tmp2__length1)) {
#line 280 "../src/Widgets/LabelWithWidgets.vala"
					break;
#line 1723 "LabelWithWidgets.c"
				}
#line 281 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = self->priv->widget_widths;
#line 281 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3__length1 = self->priv->widget_widths_length1;
#line 281 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_[i] = 0;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_ = self->priv->widget_heights;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4__length1 = self->priv->widget_heights_length1;
#line 282 "../src/Widgets/LabelWithWidgets.vala"
				_tmp4_[i] = 0;
#line 1737 "LabelWithWidgets.c"
			}
		}
	}
#line 284 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 1743 "LabelWithWidgets.c"
}

static gint
tuba_widgets_label_with_widgets_pango_pixels (TubaWidgetsLabelWithWidgets* self,
                                              gint d)
{
	gint result;
#line 287 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	result = (d + 512) >> 10;
#line 288 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1757 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_real_add_child (GtkBuildable* base,
                                                GtkBuilder* builder,
                                                GObject* child,
                                                const gchar* type)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 291 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) base;
#line 291 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (builder != NULL);
#line 291 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (child != NULL);
#line 292 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_widget_get_type ()) ? ((GtkWidget*) child) : NULL);
#line 292 "../src/Widgets/LabelWithWidgets.vala"
	widget = _tmp0_;
#line 293 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = widget;
#line 293 "../src/Widgets/LabelWithWidgets.vala"
	if (_tmp1_ != NULL) {
#line 1784 "LabelWithWidgets.c"
		GtkWidget* _tmp2_;
#line 294 "../src/Widgets/LabelWithWidgets.vala"
		_tmp2_ = widget;
#line 294 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_append_child (self, _tmp2_);
#line 1790 "LabelWithWidgets.c"
	} else {
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
#line 296 "../src/Widgets/LabelWithWidgets.vala"
		_tmp3_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 296 "../src/Widgets/LabelWithWidgets.vala"
		_tmp4_ = _tmp3_;
#line 296 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_gtk_buildable_parent_iface->add_child ((GtkBuildable*) _tmp4_, builder, child, type);
#line 1800 "LabelWithWidgets.c"
	}
#line 299 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface->add_child ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), builder, child, type);
#line 291 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (widget);
#line 1806 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_construct (GType object_type)
{
	TubaWidgetsLabelWithWidgets * self = NULL;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = (TubaWidgetsLabelWithWidgets*) g_object_new (object_type, NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return self;
#line 1817 "LabelWithWidgets.c"
}

TubaWidgetsLabelWithWidgets*
tuba_widgets_label_with_widgets_new (void)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	return tuba_widgets_label_with_widgets_construct (TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS);
#line 1825 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_placeholder (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 19 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_placeholder;
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 20 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1841 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_placeholder (TubaWidgetsLabelWithWidgets* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 22 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 23 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp0_;
#line 24 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 22 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY]);
#line 1861 "LabelWithWidgets.c"
}

const gchar*
tuba_widgets_label_with_widgets_get_text (TubaWidgetsLabelWithWidgets* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->priv->_text;
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 31 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1877 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_text (TubaWidgetsLabelWithWidgets* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
	GtkLabel* _tmp1_;
#line 33 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_strdup (value);
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 34 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp0_;
#line 35 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 36 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 36 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify ((GObject*) _tmp1_, "label");
#line 33 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY]);
#line 1902 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_ellipsize (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 42 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_ellipsize;
#line 43 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1915 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_ellipsize (TubaWidgetsLabelWithWidgets* self,
                                               gboolean value)
{
#line 45 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_ellipsize = value;
#line 47 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_update_label (self);
#line 45 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY]);
#line 1930 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_use_markup (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
#line 53 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/Widgets/LabelWithWidgets.vala"
	result = self->priv->_use_markup;
#line 54 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1943 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_use_markup (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 56 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = value;
#line 58 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 58 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_use_markup (_tmp0_, self->priv->_use_markup);
#line 56 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY]);
#line 1961 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_single_line_mode (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_single_line_mode (_tmp0_);
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 305 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 1983 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_single_line_mode (TubaWidgetsLabelWithWidgets* self,
                                                      gboolean value)
{
	GtkLabel* _tmp0_;
#line 306 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 306 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_single_line_mode (_tmp0_, value);
#line 306 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY]);
#line 1999 "LabelWithWidgets.c"
}

gfloat
tuba_widgets_label_with_widgets_get_xalign (TubaWidgetsLabelWithWidgets* self)
{
	gfloat result;
	GtkLabel* _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_xalign (_tmp0_);
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 310 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2021 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_xalign (TubaWidgetsLabelWithWidgets* self,
                                            gfloat value)
{
	GtkLabel* _tmp0_;
#line 311 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 311 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, value);
#line 311 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY]);
#line 2037 "LabelWithWidgets.c"
}

gboolean
tuba_widgets_label_with_widgets_get_selectable (TubaWidgetsLabelWithWidgets* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_selectable (_tmp0_);
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 315 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2059 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_selectable (TubaWidgetsLabelWithWidgets* self,
                                                gboolean value)
{
	GtkLabel* _tmp0_;
#line 316 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 316 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_selectable (_tmp0_, value);
#line 316 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY]);
#line 2075 "LabelWithWidgets.c"
}

gint
tuba_widgets_label_with_widgets_get_lines (TubaWidgetsLabelWithWidgets* self)
{
	gint result;
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_lines (_tmp0_);
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 320 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2097 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_lines (TubaWidgetsLabelWithWidgets* self,
                                           gint value)
{
	GtkLabel* _tmp0_;
#line 321 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 321 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_lines (_tmp0_, value);
#line 321 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY]);
#line 2113 "LabelWithWidgets.c"
}

GtkJustification
tuba_widgets_label_with_widgets_get_justify (TubaWidgetsLabelWithWidgets* self)
{
	GtkJustification result;
	GtkLabel* _tmp0_;
	GtkJustification _tmp1_;
	GtkJustification _tmp2_;
#line 325 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 325 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 325 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = gtk_label_get_justify (_tmp0_);
#line 325 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = _tmp1_;
#line 325 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp2_;
#line 325 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2135 "LabelWithWidgets.c"
}

void
tuba_widgets_label_with_widgets_set_justify (TubaWidgetsLabelWithWidgets* self,
                                             GtkJustification value)
{
	GtkLabel* _tmp0_;
#line 326 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (self != NULL);
#line 326 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 326 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_justify (_tmp0_, value);
#line 326 "../src/Widgets/LabelWithWidgets.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY]);
#line 2151 "LabelWithWidgets.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__STRING (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__STRING) (gpointer data1, const char* arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (return_value != NULL);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_return_if_fail (n_param_values == 2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = closure->data;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = param_values->data[0].v_pointer;
#line 2179 "LabelWithWidgets.c"
	} else {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data1 = param_values->data[0].v_pointer;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		data2 = closure->data;
#line 2185 "LabelWithWidgets.c"
	}
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	callback = (GMarshalFunc_BOOLEAN__STRING) (marshal_data ? marshal_data : cc->callback);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	v_return = callback (data1, g_value_get_string (param_values + 1), data2);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_value_set_boolean (return_value, v_return);
#line 2193 "LabelWithWidgets.c"
}

static gboolean
_tuba_widgets_label_with_widgets___lambda48_ (TubaWidgetsLabelWithWidgets* self,
                                              const gchar* url)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	g_return_val_if_fail (url != NULL, FALSE);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_emit (self, tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL], 0, url, &_tmp0_);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	result = _tmp0_;
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2210 "LabelWithWidgets.c"
}

static gboolean
__tuba_widgets_label_with_widgets___lambda48__gtk_label_activate_link (GtkLabel* _sender,
                                                                       const gchar* uri,
                                                                       gpointer self)
{
	gboolean result;
	result = _tuba_widgets_label_with_widgets___lambda48_ ((TubaWidgetsLabelWithWidgets*) self, uri);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	return result;
#line 2222 "LabelWithWidgets.c"
}

static void
_tuba_widgets_label_with_widgets___lambda49_ (TubaWidgetsLabelWithWidgets* self)
{
#line 77 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_invalidate_child_widgets (self);
#line 2230 "LabelWithWidgets.c"
}

static void
__tuba_widgets_label_with_widgets___lambda49__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 76 "../src/Widgets/LabelWithWidgets.vala"
	_tuba_widgets_label_with_widgets___lambda49_ ((TubaWidgetsLabelWithWidgets*) self);
#line 2240 "LabelWithWidgets.c"
}

static GObject *
tuba_widgets_label_with_widgets_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	parent_class = G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class);
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap (_tmp0_, TRUE);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_wrap_mode (_tmp0_, PANGO_WRAP_WORD_CHAR);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_label_set_xalign (_tmp0_, 0.0f);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	g_object_ref_sink (_tmp0_);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 65 "../src/Widgets/LabelWithWidgets.vala"
	self->label = _tmp0_;
#line 73 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->label;
#line 73 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp1_, (GtkWidget*) self);
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = self->label;
#line 75 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_connect_object (_tmp2_, "activate-link", (GCallback) __tuba_widgets_label_with_widgets___lambda48__gtk_label_activate_link, self, 0);
#line 76 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = self->label;
#line 76 "../src/Widgets/LabelWithWidgets.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::label", (GCallback) __tuba_widgets_label_with_widgets___lambda49__g_object_notify, self, 0);
#line 64 "../src/Widgets/LabelWithWidgets.vala"
	return obj;
#line 2291 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_class_init (TubaWidgetsLabelWithWidgetsClass * klass,
                                            gpointer klass_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_parent_class = g_type_class_peek_parent (klass);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_type_class_adjust_private_offset (klass, &TubaWidgetsLabelWithWidgets_private_offset);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) tuba_widgets_label_with_widgets_real_size_allocate;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) tuba_widgets_label_with_widgets_real_get_request_mode;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) tuba_widgets_label_with_widgets_real_measure;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuba_widgets_label_with_widgets_get_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuba_widgets_label_with_widgets_set_property;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->constructor = tuba_widgets_label_with_widgets_constructor;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (klass)->finalize = tuba_widgets_label_with_widgets_finalize;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY] = g_param_spec_string ("placeholder", "placeholder", "placeholder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY] = g_param_spec_boolean ("ellipsize", "ellipsize", "ellipsize", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY] = g_param_spec_boolean ("use-markup", "use-markup", "use-markup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY] = g_param_spec_boolean ("single-line-mode", "single-line-mode", "single-line-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY] = g_param_spec_float ("xalign", "xalign", "xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY] = g_param_spec_boolean ("selectable", "selectable", "selectable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY] = g_param_spec_int ("lines", "lines", "lines", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY, tuba_widgets_label_with_widgets_properties[TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY] = g_param_spec_enum ("justify", "justify", "justify", gtk_justification_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_signals[TUBA_WIDGETS_LABEL_WITH_WIDGETS_ACTIVATE_LINK_SIGNAL] = g_signal_new ("activate-link", TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__STRING, G_TYPE_BOOLEAN, 1, G_TYPE_STRING);
#line 2336 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_buildable_interface_init (GtkBuildableIface * iface,
                                                              gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	iface->add_child = (void (*) (GtkBuildable*, GtkBuilder*, GObject*, const gchar*)) tuba_widgets_label_with_widgets_real_add_child;
#line 2347 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_gtk_accessible_interface_init (GtkAccessibleInterface * iface,
                                                               gpointer iface_data)
{
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	tuba_widgets_label_with_widgets_gtk_accessible_parent_iface = g_type_interface_peek_parent (iface);
#line 2356 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_instance_init (TubaWidgetsLabelWithWidgets * self,
                                               gpointer klass)
{
	GtkWidget** _tmp0_;
	gint* _tmp1_;
	gint* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self->priv = tuba_widgets_label_with_widgets_get_instance_private (self);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = g_new0 (GtkWidget*, 0 + 1);
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = _tmp0_;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets_length1 = 0;
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widgets_size_ = self->priv->widgets_length1;
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = g_new0 (gint, 0);
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = _tmp1_;
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights_length1 = 0;
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_heights_size_ = self->priv->widget_heights_length1;
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	_tmp2_ = g_new0 (gint, 0);
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = _tmp2_;
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths_length1 = 0;
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_widget_widths_size_ = self->priv->widget_widths_length1;
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	_tmp3_ = g_strdup ("<widget>");
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_placeholder = _tmp3_;
#line 28 "../src/Widgets/LabelWithWidgets.vala"
	_tmp4_ = g_strdup ("");
#line 28 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_text = _tmp4_;
#line 40 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_ellipsize = FALSE;
#line 51 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->_use_markup = FALSE;
#line 2406 "LabelWithWidgets.c"
}

static void
tuba_widgets_label_with_widgets_finalize (GObject * obj)
{
	TubaWidgetsLabelWithWidgets * self;
	GtkLabel* _tmp0_;
	GtkWidget** _tmp1_;
	gint _tmp1__length1;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 81 "../src/Widgets/LabelWithWidgets.vala"
	_tmp0_ = self->label;
#line 81 "../src/Widgets/LabelWithWidgets.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 82 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1_ = self->priv->widgets;
#line 82 "../src/Widgets/LabelWithWidgets.vala"
	_tmp1__length1 = self->priv->widgets_length1;
#line 2426 "LabelWithWidgets.c"
	{
		GtkWidget** child_collection = NULL;
		gint child_collection_length1 = 0;
		gint _child_collection_size_ = 0;
		gint child_it = 0;
#line 82 "../src/Widgets/LabelWithWidgets.vala"
		child_collection = _tmp1_;
#line 82 "../src/Widgets/LabelWithWidgets.vala"
		child_collection_length1 = _tmp1__length1;
#line 82 "../src/Widgets/LabelWithWidgets.vala"
		for (child_it = 0; child_it < child_collection_length1; child_it = child_it + 1) {
#line 2438 "LabelWithWidgets.c"
			GtkWidget* _tmp2_;
			GtkWidget* child = NULL;
#line 82 "../src/Widgets/LabelWithWidgets.vala"
			_tmp2_ = _g_object_ref0 (child_collection[child_it]);
#line 82 "../src/Widgets/LabelWithWidgets.vala"
			child = _tmp2_;
#line 2445 "LabelWithWidgets.c"
			{
				GtkWidget* _tmp3_;
#line 83 "../src/Widgets/LabelWithWidgets.vala"
				_tmp3_ = child;
#line 83 "../src/Widgets/LabelWithWidgets.vala"
				gtk_widget_unparent (_tmp3_);
#line 82 "../src/Widgets/LabelWithWidgets.vala"
				_g_object_unref0 (child);
#line 2454 "LabelWithWidgets.c"
			}
		}
	}
#line 11 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widgets = (_vala_array_free (self->priv->widgets, self->priv->widgets_length1, (GDestroyNotify) g_object_unref), NULL);
#line 12 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_heights = (g_free (self->priv->widget_heights), NULL);
#line 13 "../src/Widgets/LabelWithWidgets.vala"
	self->priv->widget_widths = (g_free (self->priv->widget_widths), NULL);
#line 15 "../src/Widgets/LabelWithWidgets.vala"
	_g_object_unref0 (self->label);
#line 17 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_placeholder);
#line 28 "../src/Widgets/LabelWithWidgets.vala"
	_g_free0 (self->priv->_text);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	G_OBJECT_CLASS (tuba_widgets_label_with_widgets_parent_class)->finalize (obj);
#line 2472 "LabelWithWidgets.c"
}

 G_GNUC_NO_INLINE static GType
tuba_widgets_label_with_widgets_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TubaWidgetsLabelWithWidgetsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuba_widgets_label_with_widgets_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TubaWidgetsLabelWithWidgets), 0, (GInstanceInitFunc) tuba_widgets_label_with_widgets_instance_init, NULL };
	static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gtk_accessible_info = { (GInterfaceInitFunc) tuba_widgets_label_with_widgets_gtk_accessible_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType tuba_widgets_label_with_widgets_type_id;
	tuba_widgets_label_with_widgets_type_id = g_type_register_static (gtk_widget_get_type (), "TubaWidgetsLabelWithWidgets", &g_define_type_info, 0);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_buildable_get_type (), &gtk_buildable_info);
	g_type_add_interface_static (tuba_widgets_label_with_widgets_type_id, gtk_accessible_get_type (), &gtk_accessible_info);
	TubaWidgetsLabelWithWidgets_private_offset = g_type_add_instance_private (tuba_widgets_label_with_widgets_type_id, sizeof (TubaWidgetsLabelWithWidgetsPrivate));
	return tuba_widgets_label_with_widgets_type_id;
}

GType
tuba_widgets_label_with_widgets_get_type (void)
{
	static gsize tuba_widgets_label_with_widgets_type_id__once = 0;
	if (g_once_init_enter (&tuba_widgets_label_with_widgets_type_id__once)) {
		GType tuba_widgets_label_with_widgets_type_id;
		tuba_widgets_label_with_widgets_type_id = tuba_widgets_label_with_widgets_get_type_once ();
		g_once_init_leave (&tuba_widgets_label_with_widgets_type_id__once, tuba_widgets_label_with_widgets_type_id);
	}
	return tuba_widgets_label_with_widgets_type_id__once;
}

static void
_vala_tuba_widgets_label_with_widgets_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_placeholder (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_string (value, tuba_widgets_label_with_widgets_get_text (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_ellipsize (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_use_markup (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_single_line_mode (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_float (value, tuba_widgets_label_with_widgets_get_xalign (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_boolean (value, tuba_widgets_label_with_widgets_get_selectable (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_int (value, tuba_widgets_label_with_widgets_get_lines (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		g_value_set_enum (value, tuba_widgets_label_with_widgets_get_justify (self));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2565 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2571 "LabelWithWidgets.c"
	}
}

static void
_vala_tuba_widgets_label_with_widgets_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	TubaWidgetsLabelWithWidgets * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_LABEL_WITH_WIDGETS, TubaWidgetsLabelWithWidgets);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
	switch (property_id) {
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_PLACEHOLDER_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_placeholder (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_TEXT_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_text (self, g_value_get_string (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_ELLIPSIZE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_ellipsize (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_USE_MARKUP_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_use_markup (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SINGLE_LINE_MODE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_single_line_mode (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_XALIGN_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_xalign (self, g_value_get_float (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_SELECTABLE_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_selectable (self, g_value_get_boolean (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_LINES_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_lines (self, g_value_get_int (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		case TUBA_WIDGETS_LABEL_WITH_WIDGETS_JUSTIFY_PROPERTY:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		tuba_widgets_label_with_widgets_set_justify (self, g_value_get_enum (value));
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2639 "LabelWithWidgets.c"
		default:
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 10 "../src/Widgets/LabelWithWidgets.vala"
		break;
#line 2645 "LabelWithWidgets.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

