public class Tuba.Locale : GLib.Object {
	public string locale { get; set; }
	public string en_name { get; set; }
	public string name { get; set; }

	public Locale (string? locale, string? en_name, string? name) {
		Object (locale: locale, en_name: en_name, name: name);
	}

    public static EqualFunc<string> compare = (a, b) => {
		return ((Tuba.Locale) a).locale == ((Tuba.Locale) b).locale;
	};
}


Gee.ArrayList<Tuba.Locale> generate_iso_639_1() {
    return new Gee.ArrayList<Tuba.Locale>.wrap({
            new Tuba.Locale("aa", "Afar", "Afaraf"),
            new Tuba.Locale("ab", "Abkhaz", "аҧсуа бызшәа"),
            new Tuba.Locale("ae", "Avestan", "avesta"),
            new Tuba.Locale("af", "Afrikaans", "Afrikaans"),
            new Tuba.Locale("ak", "Akan", "Akan"),
            new Tuba.Locale("am", "Amharic", "አማርኛ"),
            new Tuba.Locale("an", "Aragonese", "aragonés"),
            new Tuba.Locale("ar", "Arabic", "اللغة العربية"),
            new Tuba.Locale("as", "Assamese", "অসমীয়া"),
            //  new Tuba.Locale("ast", "Asturian", "Asturianu"), // ISO-639-3
            new Tuba.Locale("av", "Avaric", "авар мацӀ"),
            new Tuba.Locale("ay", "Aymara", "aymar aru"),
            new Tuba.Locale("az", "Azerbaijani", "azərbaycan dili"),
            new Tuba.Locale("ba", "Bashkir", "башҡорт теле"),
            new Tuba.Locale("be", "Belarusian", "беларуская мова"),
            new Tuba.Locale("bg", "Bulgarian", "български език"),
            new Tuba.Locale("bh", "Bihari", "भोजपुरी"),
            new Tuba.Locale("bi", "Bislama", "Bislama"),
            new Tuba.Locale("bm", "Bambara", "bamanankan"),
            new Tuba.Locale("bn", "Bengali", "বাংলা"),
            new Tuba.Locale("bo", "Tibetan", "བོད་ཡིག"),
            new Tuba.Locale("br", "Breton", "brezhoneg"),
            new Tuba.Locale("bs", "Bosnian", "bosanski jezik"),
            new Tuba.Locale("ca", "Catalan", "Català"),
            new Tuba.Locale("ce", "Chechen", "нохчийн мотт"),
            new Tuba.Locale("ch", "Chamorro", "Chamoru"),
            //  new Tuba.Locale("ckb", "Sorani (Kurdish)", "سۆرانی"), // ISO-639-3
            //  new Tuba.Locale("cnr", "Montenegrin", "crnogorski"), // ISO-639-3
            new Tuba.Locale("co", "Corsican", "corsu"),
            new Tuba.Locale("cr", "Cree", "ᓀᐦᐃᔭᐍᐏᐣ"),
            new Tuba.Locale("cs", "Czech", "čeština"),
            new Tuba.Locale("cu", "Old Church Slavonic", "ѩзыкъ словѣньскъ"),
            new Tuba.Locale("cv", "Chuvash", "чӑваш чӗлхи"),
            new Tuba.Locale("cy", "Welsh", "Cymraeg"),
            new Tuba.Locale("da", "Danish", "dansk"),
            new Tuba.Locale("de", "German", "Deutsch"),
            new Tuba.Locale("dv", "Divehi", "Dhivehi"),
            new Tuba.Locale("dz", "Dzongkha", "རྫོང་ཁ"),
            new Tuba.Locale("ee", "Ewe", "Eʋegbe"),
            new Tuba.Locale("el", "Greek", "Ελληνικά"),
            new Tuba.Locale("en", "English", "English"),
            new Tuba.Locale("eo", "Esperanto", "Esperanto"),
            new Tuba.Locale("es", "Spanish", "Español"),
            new Tuba.Locale("et", "Estonian", "eesti"),
            new Tuba.Locale("eu", "Basque", "euskara"),
            new Tuba.Locale("fa", "Persian", "فارسی"),
            new Tuba.Locale("ff", "Fula", "Fulfulde"),
            new Tuba.Locale("fi", "Finnish", "suomi"),
            new Tuba.Locale("fj", "Fijian", "Vakaviti"),
            new Tuba.Locale("fo", "Faroese", "føroyskt"),
            new Tuba.Locale("fr", "French", "Français"),
            new Tuba.Locale("fy", "Western Frisian", "Frysk"),
            new Tuba.Locale("ga", "Irish", "Gaeilge"),
            new Tuba.Locale("gd", "Scottish Gaelic", "Gàidhlig"),
            new Tuba.Locale("gl", "Galician", "galego"),
            new Tuba.Locale("gu", "Gujarati", "ગુજરાતી"),
            new Tuba.Locale("gv", "Manx", "Gaelg"),
            new Tuba.Locale("ha", "Hausa", "هَوُسَ"),
            new Tuba.Locale("he", "Hebrew", "עברית"),
            new Tuba.Locale("hi", "Hindi", "हिन्दी"),
            new Tuba.Locale("ho", "Hiri Motu", "Hiri Motu"),
            new Tuba.Locale("hr", "Croatian", "Hrvatski"),
            new Tuba.Locale("ht", "Haitian", "Kreyòl ayisyen"),
            new Tuba.Locale("hu", "Hungarian", "magyar"),
            new Tuba.Locale("hy", "Armenian", "Հայերեն"),
            new Tuba.Locale("hz", "Herero", "Otjiherero"),
            new Tuba.Locale("ia", "Interlingua", "Interlingua"),
            new Tuba.Locale("id", "Indonesian", "Bahasa Indonesia"),
            new Tuba.Locale("ie", "Interlingue", "Interlingue"),
            new Tuba.Locale("ig", "Igbo", "Asụsụ Igbo"),
            new Tuba.Locale("ii", "Nuosu", "ꆈꌠ꒿ Nuosuhxop"),
            new Tuba.Locale("ik", "Inupiaq", "Iñupiaq"),
            new Tuba.Locale("io", "Ido", "Ido"),
            new Tuba.Locale("is", "Icelandic", "Íslenska"),
            new Tuba.Locale("it", "Italian", "Italiano"),
            new Tuba.Locale("iu", "Inuktitut", "ᐃᓄᒃᑎᑐᑦ"),
            new Tuba.Locale("ja", "Japanese", "日本語"),
            //  new Tuba.Locale("jbo", "Lojban", "la .lojban."), // ISO-639-3
            new Tuba.Locale("jv", "Javanese", "basa Jawa"),
            new Tuba.Locale("ka", "Georgian", "ქართული"),
            //  new Tuba.Locale("kab", "Kabyle", "Taqbaylit"), // ISO-639-3
            new Tuba.Locale("kg", "Kongo", "Kikongo"),
            new Tuba.Locale("ki", "Kikuyu", "Gĩkũyũ"),
            new Tuba.Locale("kj", "Kwanyama", "Kuanyama"),
            new Tuba.Locale("kk", "Kazakh", "қазақ тілі"),
            new Tuba.Locale("kl", "Kalaallisut", "kalaallisut"),
            new Tuba.Locale("km", "Khmer", "ខេមរភាសា"),
            //  new Tuba.Locale("kmr", "Kurmanji (Kurdish)", "Kurmancî"), // ISO-639-3
            new Tuba.Locale("kn", "Kannada", "ಕನ್ನಡ"),
            new Tuba.Locale("ko", "Korean", "한국어"),
            new Tuba.Locale("kr", "Kanuri", "Kanuri"),
            new Tuba.Locale("ks", "Kashmiri", "कश्मीरी"),
            new Tuba.Locale("ku", "Kurmanji (Kurdish)", "Kurmancî"),
            new Tuba.Locale("kv", "Komi", "коми кыв"),
            new Tuba.Locale("kw", "Cornish", "Kernewek"),
            new Tuba.Locale("ky", "Kyrgyz", "Кыргызча"),
            new Tuba.Locale("la", "Latin", "latine"),
            new Tuba.Locale("lb", "Luxembourgish", "Lëtzebuergesch"),
            //  new Tuba.Locale("ldn", "Láadan", "Láadan"), // ISO-639-3
            //  new Tuba.Locale("lfn", "Lingua Franca Nova", "lingua franca nova"), // ISO-639-3
            new Tuba.Locale("lg", "Ganda", "Luganda"),
            new Tuba.Locale("li", "Limburgish", "Limburgs"),
            new Tuba.Locale("ln", "Lingala", "Lingála"),
            new Tuba.Locale("lo", "Lao", "ລາວ"),
            new Tuba.Locale("lt", "Lithuanian", "lietuvių kalba"),
            new Tuba.Locale("lu", "Luba-Katanga", "Tshiluba"),
            new Tuba.Locale("lv", "Latvian", "latviešu valoda"),
            new Tuba.Locale("mg", "Malagasy", "fiteny malagasy"),
            new Tuba.Locale("mh", "Marshallese", "Kajin M̧ajeļ"),
            new Tuba.Locale("mi", "Māori", "te reo Māori"),
            new Tuba.Locale("mk", "Macedonian", "македонски јазик"),
            new Tuba.Locale("ml", "Malayalam", "മലയാളം"),
            new Tuba.Locale("mn", "Mongolian", "Монгол хэл"),
            new Tuba.Locale("mr", "Marathi", "मराठी"),
            new Tuba.Locale("ms", "Malay", "Bahasa Melayu"),
            new Tuba.Locale("mt", "Maltese", "Malti"),
            new Tuba.Locale("my", "Burmese", "ဗမာစာ"),
            new Tuba.Locale("na", "Nauru", "Ekakairũ Naoero"),
            new Tuba.Locale("nb", "Norwegian Bokmål", "Norsk bokmål"),
            new Tuba.Locale("nd", "Northern Ndebele", "isiNdebele"),
            new Tuba.Locale("ne", "Nepali", "नेपाली"),
            new Tuba.Locale("ng", "Ndonga", "Owambo"),
            new Tuba.Locale("nl", "Dutch", "Nederlands"),
            new Tuba.Locale("nn", "Norwegian Nynorsk", "Norsk Nynorsk"),
            new Tuba.Locale("no", "Norwegian", "Norsk"),
            new Tuba.Locale("nr", "Southern Ndebele", "isiNdebele"),
            new Tuba.Locale("nv", "Navajo", "Diné bizaad"),
            new Tuba.Locale("ny", "Chichewa", "chiCheŵa"),
            new Tuba.Locale("oc", "Occitan", "occitan"),
            new Tuba.Locale("oj", "Ojibwe", "ᐊᓂᔑᓈᐯᒧᐎᓐ"),
            new Tuba.Locale("om", "Oromo", "Afaan Oromoo"),
            new Tuba.Locale("or", "Oriya", "ଓଡ଼ିଆ"),
            new Tuba.Locale("os", "Ossetian", "ирон æвзаг"),
            new Tuba.Locale("pa", "Panjabi", "ਪੰਜਾਬੀ"),
            new Tuba.Locale("pi", "Pāli", "पाऴि"),
            new Tuba.Locale("pl", "Polish", "Polski"),
            new Tuba.Locale("ps", "Pashto", "پښتو"),
            new Tuba.Locale("pt", "Portuguese", "Português"),
            new Tuba.Locale("qu", "Quechua", "Runa Simi"),
            new Tuba.Locale("rm", "Romansh", "rumantsch grischun"),
            new Tuba.Locale("rn", "Kirundi", "Ikirundi"),
            new Tuba.Locale("ro", "Romanian", "Română"),
            new Tuba.Locale("ru", "Russian", "Русский"),
            new Tuba.Locale("rw", "Kinyarwanda", "Ikinyarwanda"),
            new Tuba.Locale("sa", "Sanskrit", "संस्कृतम्"),
            new Tuba.Locale("sc", "Sardinian", "sardu"),
            //  new Tuba.Locale("sco", "Scots", "Scots"), // ISO-639-3
            new Tuba.Locale("sd", "Sindhi", "सिन्धी"),
            new Tuba.Locale("se", "Northern Sami", "Davvisámegiella"),
            new Tuba.Locale("sg", "Sango", "yângâ tî sängö"),
            new Tuba.Locale("si", "Sinhala", "සිංහල"),
            new Tuba.Locale("sk", "Slovak", "slovenčina"),
            new Tuba.Locale("sl", "Slovenian", "slovenščina"),
            //  new Tuba.Locale("sma", "Southern Sami", "Åarjelsaemien Gïele"), // ISO-639-3
            //  new Tuba.Locale("smj", "Lule Sami", "Julevsámegiella"), // ISO-639-3
            new Tuba.Locale("sn", "Shona", "chiShona"),
            new Tuba.Locale("so", "Somali", "Soomaaliga"),
            new Tuba.Locale("sq", "Albanian", "Shqip"),
            new Tuba.Locale("sr", "Serbian", "српски језик"),
            new Tuba.Locale("ss", "Swati", "SiSwati"),
            new Tuba.Locale("st", "Southern Sotho", "Sesotho"),
            new Tuba.Locale("su", "Sundanese", "Basa Sunda"),
            new Tuba.Locale("sv", "Swedish", "Svenska"),
            new Tuba.Locale("sw", "Swahili", "Kiswahili"),
            //  new Tuba.Locale("szl", "Silesian", "ślůnsko godka"), // ISO-639-3
            new Tuba.Locale("ta", "Tamil", "தமிழ்"),
            //  new Tuba.Locale("tai", "Tai", "ภาษาไท or ภาษาไต"), // ISO-639-3
            new Tuba.Locale("te", "Telugu", "తెలుగు"),
            new Tuba.Locale("tg", "Tajik", "тоҷикӣ"),
            new Tuba.Locale("th", "Thai", "ไทย"),
            new Tuba.Locale("ti", "Tigrinya", "ትግርኛ"),
            new Tuba.Locale("tk", "Turkmen", "Türkmen"),
            new Tuba.Locale("tl", "Tagalog", "Wikang Tagalog"),
            new Tuba.Locale("tn", "Tswana", "Setswana"),
            new Tuba.Locale("to", "Tonga", "faka Tonga"),
            //  new Tuba.Locale("tok", "Toki Pona", "toki pona"), // ISO-639-3
            new Tuba.Locale("tr", "Turkish", "Türkçe"),
            new Tuba.Locale("ts", "Tsonga", "Xitsonga"),
            new Tuba.Locale("tt", "Tatar", "татар теле"),
            new Tuba.Locale("tw", "Twi", "Twi"),
            new Tuba.Locale("ty", "Tahitian", "Reo Tahiti"),
            new Tuba.Locale("ug", "Uyghur", "ئۇيغۇرچە‎"),
            new Tuba.Locale("uk", "Ukrainian", "Українська"),
            new Tuba.Locale("ur", "Urdu", "اردو"),
            new Tuba.Locale("uz", "Uzbek", "Ўзбек"),
            new Tuba.Locale("ve", "Venda", "Tshivenḓa"),
            new Tuba.Locale("vi", "Vietnamese", "Tiếng Việt"),
            new Tuba.Locale("vo", "Volapük", "Volapük"),
            new Tuba.Locale("wa", "Walloon", "walon"),
            new Tuba.Locale("wo", "Wolof", "Wollof"),
            new Tuba.Locale("xh", "Xhosa", "isiXhosa"),
            new Tuba.Locale("yi", "Yiddish", "ייִדיש"),
            new Tuba.Locale("yo", "Yoruba", "Yorùbá"),
            new Tuba.Locale("za", "Zhuang", "Saɯ cueŋƅ"),
            //  new Tuba.Locale("zba", "Balaibalan", "باليبلن"), // ISO-639-3
            //  new Tuba.Locale("zgh", "Standard Moroccan Tamazight", "ⵜⴰⵎⴰⵣⵉⵖⵜ"), // ISO-639-3
            new Tuba.Locale("zh", "Chinese", "中文"),
            new Tuba.Locale("zu", "Zulu", "isiZulu")
    });
}